Subject: Re: [PATCH 3/5] e1000e: Allow TSO to trickle down to VLAN device

From: Patrick McHardy <[email-masked]>
Date: Wed, 30 Apr 2008 08:54:37 +0200

Waskiewicz Jr, Peter P wrote:
>> In any case I would prefer to avoid having drivers mess with VLAN
>> device flags. How about adding a device flag indicating that the
>> driver supports TSO + VLAN acceleration and using the
>> NETDEV_FEAT_CHANGE notification inside the VLAN code do adjust
>> the device's flags properly?
> 
> I've been looking into this, and I agree this makes sense when creating
> a new VLAN to get the device flags to the VLAN device.  However, we need
> to get the TSO and/or Tx checksum offload feature flags off all VLAN
> devices when the parent device has it turned off.  I don't see any clean
> way of doing this with netdev_features_change().  I'd really love to
> implement this correctly, so if you have any ideas on how to handle this
> latter case, I'm all ears.  :-)

Whats the problem with doing:

- on VLAN creation: copy VLAN flag from lower device if lowerdev
   has NETIF_F_<flag indicating non-broken TSO+VLAN accel>

- on change of TSO/checksumming flags of lower device:
   use netdevice notifier to adjust the settings for all
   VLANs on that device

-------------------------------------------------------------------------
This SF.net email is sponsored by the 2008 JavaOne(SM) Conference 
Don't miss this year's exciting event. There's still time to save $100. 
Use priority code J8TL2D2. 
http://ad.doubleclick.net/clk;198757673;13503038;p?http://java.sun.com/javaone